<script>
import shortid from 'shortid';
import { mapGetters, mapState } from 'vuex';
import { POSE_TYPES_MAPPER, POSE_ACTIONS } from '~/helpers/libraries.js';

import * as posesApiRoutes from '~/helpers/api-routes/poses.js';

export default {
  name: `anim-rig-poses-detail`,
  props: {
    lib: { type: String, required: true },
    pose: { type: Object, default: null },
    simple: { type: Boolean, default: false },
    editable: { type: Boolean, default: false },
    loadingImg: { type: Boolean, default: false },
  },
  data() {
    return {
      onImg: false,
      poseData: null,

      keyframeIcon: require('../../static/keyframe.svg'),
    }
  },
  computed: {
    localName: {
      get() {
        return this.pose.name;
      },
      set(value) {
        this.pose.name = value;
      }
    },
    ...mapGetters('projects', [ 'isWriter' ]),
    ...mapState({
      username: (state) => state.users.currentUser.username,
      isAnimLead: (state) => state.users.currentUser.roles.includes(`anim-lead`),
      selectedWebsocket: (state) => state.websockets.selectedWebsocket,
      flip: (state) => state.poses.flip,
      applyOnSelected: (state) => state.poses.applyOnSelected,
      importAtCurrentFrame: (state) => state.poses.importAtCurrentFrame,
    }),
    iAmWriter() {
      return this.isWriter(this.username);
    },

    noData() {
      return this.pose.dataLength === 0;
    },
    poseType () {
      return this.pose.type;
    },
    poseCategory () {
      if (this.poseType == 'selection set') return 'pose';
      return this.poseType;
    },
    poseIsApproved () {
      if (typeof (this.pose.approved) === 'string')
        return this.pose.approved === '1';
      return this.pose.approved;
    },
  },
  mounted() {
    this.getPoseData(this.pose);
  },
  watch: {
    pose (newPose) {
      this.getPoseData(newPose);
    }
  },
  methods: {
    async getPoseData(pose) {
      if (pose) {
        const data = await this.$axios.$get(posesApiRoutes.getData(pose.id));
        this.poseData = btoa(JSON.stringify(data));
      }
    },

    getRandomHash() {
      // used to force reloading on images (and
      // "disable" caching)
      return shortid.generate();
    },
    toggleImgHover() {
      this.onImg = !this.onImg;
    },
    openCopyModal() {
      this.$emit(`open-copy-modal`);
    },
    openDeleteModal() {
      this.$emit(`open-delete-modal`);
    },
    openReviveModal() {
      this.$emit(`open-revive-modal`);
    },
    setName() {
      this.$emit(`set-name`, this.localName);
    },
    runFileUpload() {
      if (!this.editable) {
        return;
      }
      this.$refs.thumbnail.click();
    },
    runMovieFileUpload() {
      if (!this.editable) {
        return;
      }
      this.$refs[`thumbnail-movie`].click();
    },
    handleFileChange(e, endEvent, readFile) {
      const file = e.target.files[0];
      this.imgFilename = file.name;
      if (readFile) {
        const reader = new FileReader();
        reader.addEventListener(`load`, () => {
          this.$emit(endEvent, { content: reader.result });
        }, false);
        reader.readAsDataURL(file);
      } else {
        this.$emit(endEvent, e.target.files[0]);
      }
    },
    applyPose(pressingCtrl, poseType = null) {
      if (this.selectedWebsocket === ``) {
        return;
      }
      const action = POSE_ACTIONS[pressingCtrl ? 'extend' : 'replace'];
      if (poseType === null)
        poseType = this.poseType;
      this.$store.dispatch(`websockets/sendData`, {
        name: this.selectedWebsocket,
        data: { operator: `lfs.colibri_apply_pose`,
                pose_b64: this.poseData,
                flip: this.flip,
                apply_on_selected: this.applyOnSelected,
                merge_factor: 100,
                initial_merge: true,
                pose_type: POSE_TYPES_MAPPER[poseType],
                action,
                current_frame: this.importAtCurrentFrame, }
      });
    },
    getPose() {
      if (this.selectedWebsocket === ``) {
        return;
      }
      const $this = this;
      this.$store.dispatch(`websockets/sendData`, {
        name: this.selectedWebsocket,
        data: { operator: `lfs.colibri_get_pose`,
                pose_type: POSE_TYPES_MAPPER[this.poseType], },
        callback: (socket) => (event) => {
          const poseData = JSON.parse(atob(event.data.pose_b64));
          $this.$emit(`set-data`, poseData);
        },
      });
    },
    makeSnapshot() {
      if (this.selectedWebsocket === ``) {
        return;
      }
      const $this = this;
      this.$store.dispatch(`websockets/sendData`, {
        name: this.selectedWebsocket,
        data: { operator: `lfs.colibri_make_snapshot`, },
        callback: (socket) => (event) => {
          const poseImg = event.data.content;
          $this.$emit(`set-img`, { content: poseImg });
        },
      });
    },
  },
}
</script>

<template>
  <div class="pa-4" v-if="!simple">
    <input ref="thumbnail" type="file" @change="(e) => handleFileChange(e, `set-img`, true)" />
    <input ref="thumbnail-movie" type="file" name="file" @change="(e) => handleFileChange(e, `set-movie`, false)" />
    <template v-if="pose !== null">
      <v-row no-gutters align="center" justify="space-between" class="mb-2">
        <div class="text-subtitle-1">{{ $t(`anim-rig.lib-page.pose-details`) }}</div>
        <div v-if="!pose.active" class="text--disabled">({{ $t(`common.inactive`) }})</div>
        <v-row v-if="iAmWriter && editable" no-gutters class="flex-grow-0">
          <v-btn fab x-small :disabled="selectedWebsocket === ``" @click="makeSnapshot" class="mr-2">
            <v-icon>mdi-camera</v-icon>
          </v-btn>
          <v-btn v-if="pose.active" fab x-small @click="openDeleteModal">
            <v-icon>mdi-delete</v-icon>
          </v-btn>
          <v-btn v-else fab x-small @click="openReviveModal">
            <v-icon>mdi-backup-restore</v-icon>
          </v-btn>
        </v-row>
      </v-row>
      <v-btn v-if="iAmWriter" block class="my-4" @click="openCopyModal">
        {{ $t(`common.copy`) }}
      </v-btn>
      <div
        @mouseenter="toggleImgHover"
        @mouseleave="toggleImgHover"
        @click="runFileUpload"
        :class="[
          `app-anim-rig__poses-detail-thumbnail`,
          `p-rel`,
          `my-1`,
          (editable) ? `clickable` : ``
        ]"
      >
        <v-img
          :src="
            pose.thumbnail
              ? `/content/poses/${lib}/${pose.thumbnail}?${getRandomHash()}`
              : `/no-pose-image-${$vuetify.theme.dark ? 'dark' : 'light'}.png`
          "
          :width="200"
          :aspect-ratio="1"
          contain
        >
          <v-overlay v-if="loadingImg" absolute>
            <v-row
              class="fill-height ma-0"
              align="center"
              justify="center"
            >
              <v-progress-circular
                indeterminate
                color="grey lighten-5"
              ></v-progress-circular>
            </v-row>
          </v-overlay>
        </v-img>
        <div v-if="iAmWriter && editable && onImg" class="overlay-dark">
          <v-icon x-large>mdi-upload</v-icon>
        </div>
      </div>
      <v-btn
        v-if="iAmWriter && pose.type === 'animation'"
        block
        class="my-4"
        @click="runMovieFileUpload"
      >
        Upload movie
      </v-btn>
      <div class="app-anim-rig__poses-detail-info">
        <v-row no-gutters class="mb-2 flex-nowrap" align="end">
          <div class="flex-grow-1" v-if="!iAmWriter || !editable"><b>{{ pose.name }}</b></div>
          <v-text-field
            v-else
            v-model="localName"
            :label="$t(`common.name`)"
            @blur="setName"
            @keypress.enter="setName"
            hide-details
            dense
            class="mt-6"
          />
          <v-chip
            class="ml-2"
            label
            @click="applyPose(false, 'selection set')"
          >
            <template v-if="pose.type === 'animation'">
              <img :src="keyframeIcon" style="width: 24px; height: auto; margin-right: 4px;" />
              {{ pose.dataLength }}
            </template>
            <template v-else>
              <v-icon left> mdi-bone </v-icon> {{ pose.dataLength }}
            </template>
          </v-chip>
        </v-row>
      </div>
      <v-row no-gutters class="my-4" align="baseline">
        <div class="font-weight-bold">
          {{ $t(`anim-rig.lib-page.pose-type`) }}
        </div>
        <div class="mx-1">—</div>
        <div class="text-subtitle-1">
          {{ $t(`anim-rig.lib-page.pose-types.${poseType}`) }}
        </div>
      </v-row>
      <v-btn
        v-if="iAmWriter"
        block
        :disabled="noData || selectedWebsocket === ``"
        @click.ctrl="applyPose(true)"
        @click.meta="applyPose(true)"
        @click.exact="applyPose(false)"
        class="mb-2"
      >
        {{ $t(`anim-rig.lib-page.apply-${poseCategory}`) }}
      </v-btn>
      <v-btn v-if="iAmWriter && editable" block @click="getPose" :disabled="selectedWebsocket === ``">
        {{ $t(`anim-rig.lib-page.get-${poseCategory}`) }}
      </v-btn>
      <v-checkbox
        v-if="isAnimLead"
        :input-value="poseIsApproved"
        :label="$t(`common.approved`)"
        @click="$emit(`set-approved`, !poseIsApproved)"
      ></v-checkbox>
    </template>
  </div>
  <div class="pa-4" v-else>
    <div
      :class="[
        `app-anim-rig__poses-detail-thumbnail`,
        `p-rel`,
        `my-2`,
      ]"
    >
      <v-img
        :src="
          pose.thumbnail
            ? `/content/poses/${lib}/${pose.thumbnail}?${getRandomHash()}`
            : `/no-pose-image-${$vuetify.theme.dark ? 'dark' : 'light'}.png`
        "
        :width="200"
        :aspect-ratio="1"
        contain
      >
        <v-overlay v-if="loadingImg" absolute>
          <v-row
            class="fill-height ma-0"
            align="center"
            justify="center"
          >
            <v-progress-circular
              indeterminate
              color="grey lighten-5"
            ></v-progress-circular>
          </v-row>
        </v-overlay>
      </v-img>
    </div>
    <div class="app-anim-rig__poses-detail-info">
      <v-row no-gutters class="mb-2 flex-nowrap" align="center">
        <div class="flex-grow-1"><b>{{ pose.name }}</b></div>
        <v-chip class="ml-2" label @click="applyPose(false, 'selection set')">
          <v-icon left> mdi-bone </v-icon> {{ pose.dataLength }}
        </v-chip>
        <v-tooltip v-if="poseIsApproved" bottom>
          <template v-slot:activator="{ on, attrs }">
            <v-chip v-bind="attrs" v-on="on" class="ml-2" label>
              <v-icon>mdi-thumb-up</v-icon>
            </v-chip>
          </template>
          <span>Approved</span>
        </v-tooltip>
      </v-row>
    </div>
    <v-row no-gutters class="my-4" align="baseline">
      <div class="font-weight-bold">
        {{ $t(`anim-rig.lib-page.pose-type`) }}
      </div>
      <div class="mx-1">—</div>
      <div class="text-subtitle-1">
        {{ $t(`anim-rig.lib-page.pose-types.${poseType}`) }}
      </div>
    </v-row>
    <v-btn
      v-if="iAmWriter"
      block
      :disabled="noData || selectedWebsocket === ``"
      @click.ctrl="applyPose(true)"
      @click.meta="applyPose(true)"
      @click.exact="applyPose(false)"
      class="mb-2"
    >
      {{ $t(`anim-rig.lib-page.apply-${poseCategory}`) }}
    </v-btn>
    <v-btn v-if="iAmWriter && editable" block @click="getPose" :disabled="selectedWebsocket === ``">
      {{ $t(`anim-rig.lib-page.get-${poseCategory}`) }}
    </v-btn>
  </div>
</template>

<style lang="scss" scoped>
.app-anim-rig__poses-detail-thumbnail {
  border: 1px solid var(--body-color);
  border-radius: var(--border-radius);
  display: flex;
  justify-content: center;
  align-items: center;
}

.app-anim-rig__poses-detail-thumbnail > img {
  width: 100%;
  height: auto;
  border-radius: var(--border-radius);
}

.app-anim-rig__poses-detail-thumbnail > svg {
  width: 65%;
  height: 65%;
}
</style>
